<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class statue_vendor extends REF_Controller {
    public function __construct() {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('statue_vendor_model', '', TRUE);
        $this->uri_key_index = 0;
    }
    
    public function index() {
        $data = array();
        $data['results'] = $this->statue_vendor_model->list_all();
        if (!empty($this->session->flashdata('success'))) 
            $data['success'] = $this->session->flashdata('success');
        else 
            $data['error'] = $this->session->flashdata('error');
        
        $actions = $this->actions();
        $data['add_btn']    = 'Create New Vendor';
        $data['view_link']  = $actions['view'] . '/';
        $data['add_link']   = $actions['add'];
        $data['edit_link']  = $actions['edit'] . '/';
        $data['delete_link']= $actions['delete'] . '/';
        
        $service_menu_id = get_statue_controller_id($actions['controller']);
        $data['service_menu_id'] = array('service_menu_id' => $service_menu_id, 'menu_type' => '5');
        $this->render($data, 'statue_books/vendor/list');
    }
    
    private function get_item_url_key($name, $id = '') {
        $url_key = get_url_key($name);
        if ($this->statue_item_model->item_url_key_exists($url_key, $id)) {
            $this->uri_key_index ++;
            return $this->get_item_url_key($name . '_' . $this->uri_key_index, $id);
        }
        
        return $url_key;
    }
    
    public function add() {
        $data = array();
        $actions = $this->actions();
        $data['form_action'] = $actions['insert'];
        $last_id = $this->statue_vendor_model->get_last_insert_id();
        if(count($last_id) > 0) {
            $last_code = $last_id->code;
            $last_no = (int)$last_code;
            $data['code'] = (($last_no + 1)  > 9999) ? ($last_no + 1)  : sprintf('0%03d', ($last_no + 1) );
        } else
            $data['code'] = '0001';
        
        $this->render($data, 'statue_books/vendor/add');
    }
    
    public function insert() {
        $insert = array(
            'code' => $this->input->post('code'),
            'name' => $this->input->post('name'),
            'contact_no' => $this->input->post('contact_no'),
            'email' => $this->input->post('email'),
            'address' => $this->input->post('address'),
            'created_by' => $this->user_data['user_id'],
            'created_on' => date('Y-m-d H:i:s')
        );
       
        $insert_id = $this->statue_vendor_model->insert($insert);  
        if ($insert_id > 0)
            $this->session->set_flashdata('success', 'Vendor added successfully');    
        
        else
            $this->session->set_flashdata('error', 'Vendor not added!');
        redirect('statue_vendor', 'refresh');
    }
    
    public function edit($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['vendor'] = $this->statue_vendor_model->get_by_id($id);
        $actions = $this->actions();
        $data['form_action'] = $actions['update'] . '/' . $id;
        $this->render($data, 'statue_books/vendor/edit');
    }
    
    public function update($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        $update = array(
            'code' => $this->input->post('code'),
            'name' => $this->input->post('name'),
            'contact_no' => $this->input->post('contact_no'),
            'email' => $this->input->post('email'),
            'address' => $this->input->post('address'),
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        if ( $this->statue_vendor_model->update($update, $id) > 0)
            $this->session->set_flashdata('success', 'Vendor updated successfully');  
       
        else
            $this->session->set_flashdata('error', 'Vendor not updated!');    
        
        redirect('statue_vendor','refresh');
    }
    
    public function view($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['vendor'] = $this->statue_vendor_model->get_by_id($id);
        $this->render($data, 'statue_books/vendor/view');
    }
    
    public function delete($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array ( 
            'status' => 2,
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        if ($this->statue_vendor_model->update($update,$id) > 0)
            $this->session->set_flashdata('success', 'Vendor deleted successfully');
            
        else 
            $this->session->set_flashdata('error', 'Vendor not deleted!');
        
        redirect( 'statue_vendor', 'refresh');
    }
    
    public function vendor_name_exists() {
        $data =  $this->statue_vendor_model->vendor_name_exists($_POST['id'],$_POST['name']);
        echo json_encode($data);
        exit(0);
    }
}
?>